#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "tsync.h"
#include "tsync_example.h"

#include "spec_ktsal_en.h"

int main (int argc, char *argv[])
{
    if (argc != 3) {
        printf(" Usage: SW_GetIOSwitch <device> <io>\n");
        return EXIT_FAILURE;
    }

    int devId = atoi(argv[1]);

    char deviceName[32] = {0};
    sprintf(deviceName, "/dev/tsyncpci%d", devId);
    
    TSYNC_BoardHandle pHandle;
    
    if (TSYNC_open(&pHandle, deviceName) != TSYNC_SUCCESS ) {
        printf("%s: Could not open <%s>\n", argv[0], deviceName);
        return EXIT_FAILURE;
    }

    TSYNC_IOSwitchObj obj;
    uint32_t io = atoi(argv[2]);

    TSYNC_ERROR err = TSYNC_SW_getIOSwitch(pHandle, &obj, io);

    if (err != TSYNC_SUCCESS) {
        printf("  Error: %s.\n", tsync_strerror(err));
        return EXIT_FAILURE;
    }

    printf("feature: %02x;type: %02x;instance: %02x,io: %02x\n",obj.feature, obj.type, obj.instance, obj.io);
    return EXIT_SUCCESS;
}